 #
 #   $Id: Struct.pm,v 1.3 2005/03/24 23:02:46 zarahg Exp $
 #
 #   This  file  is  part of the  PodWiki  web-based authoring tool.
 #
 #   By  accessing  this software,  PodWiki,  you are  duly informed
 #   of and  agree to be  bound  by the  conditions  described below
 #   in this notice:
 #
 #   This software product, PodWiki,  is developed by  Thomas Linden
 #   and   copyrighted  (C) 2003-2005   by  Thomas Linden,  with all
 #   rights reserved.
 #
 #   There is  no charge for  PodWiki software. You can redistribute
 #   it and/or modify it under  the terms of the  GNU General Public
 #   License, which is incorporated by reference herein.
 #
 #   PodWiki is distributed WITHOUT ANY WARRANTY,IMPLIED OR EXPRESS,
 #   OF  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE or that
 #   the  use of it will not infringe on any third party's intellec-
 #   tual property rights.
 #
 #   You  should  have  received a  copy  of  the GNU General Public
 #   License along with PodWiki.  Copies  can also be obtained from:
 #
 #     http://www.gnu.org/copyleft/gpl.html
 #
 #   or by writing to:
 #
 #     Free Software Foundation, Inc.
 #     59 Temple Place, Suite 330
 #     Boston, MA 02111-1307
 #     USA
 #
 #   Or contact:
 #
 #    "Thomas Linden" <tom@daemon.de>
 #
 #   Additional Copyrights:
 #
 #


=head1 NAME

PodWiki::Struct - Interface for structure persistence

=cut




package PodWiki::Struct;

$PodWiki::Struct::VERSION = "1.00";

use lib qw(. lib);
use Storable qw(lock_store lock_retrieve);
use strict;
no strict "refs";
use Carp;
use Exporter;
use Rcs;

use vars qw(@ISA @EXPORT @EXPORT_OK @EXPORT_TAGS $AUTOLOAD);

@ISA=qw(Exporter);
@EXPORT=qw();
@EXPORT_OK=qw();
@EXPORT_TAGS=();




sub fetch {
  my($file) = @_;
  if (-r $file) {
    return lock_retrieve(&untaint($file)) or croak "Cant retrieve struct: $!\n";
  }
  else {
    # ignore non-existent file
    return {};
  }
}


sub store {
  my($ref, $file) = @_;
  lock_store($ref, &untaint($file)) or croak "Cant store struct: $!\n";
}

sub untaint {
  if ($_[0] =~ /^(.*)$/) {
    return $1;
  }
}

1;
