#!/usr/bin/perl

 #
 #   $Id: dbm2storable.pl,v 1.6 2005/03/24 23:02:47 zarahg Exp $
 #
 #   This  file  is  part of the  PodWiki  web-based authoring tool.
 #
 #   By  accessing  this software,  PodWiki,  you are  duly informed
 #   of and  agree to be  bound  by the  conditions  described below
 #   in this notice:
 #
 #   This software product, PodWiki,  is developed by  Thomas Linden
 #   and   copyrighted  (C) 2003-2005   by  Thomas Linden,  with all
 #   rights reserved.
 #
 #   There is  no charge for  PodWiki software. You can redistribute
 #   it and/or modify it under  the terms of the  GNU General Public
 #   License, which is incorporated by reference herein.
 #
 #   PodWiki is distributed WITHOUT ANY WARRANTY,IMPLIED OR EXPRESS,
 #   OF  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE or that
 #   the  use of it will not infringe on any third party's intellec-
 #   tual property rights.
 #
 #   You  should  have  received a  copy  of  the GNU General Public
 #   License along with PodWiki.  Copies  can also be obtained from:
 #
 #     http://www.gnu.org/copyleft/gpl.html
 #
 #   or by writing to:
 #
 #     Free Software Foundation, Inc.
 #     59 Temple Place, Suite 330
 #     Boston, MA 02111-1307
 #     USA
 #
 #   Or contact:
 #
 #    "Thomas Linden" <tom@daemon.de>
 #
 #   Additional Copyrights:
 #
 #


use DB_File;
use MLDBM qw(DB_File Storable);
use Storable qw(lock_store);
use Data::Dumper;

my($type, $file) = @ARGV;

if (! $type && ! $file) {
  print STDERR "Usage: $0 <type> <file>\n";
  exit;
}

if (-e $file) {
  my $ftype = `file $file`;
  if ($ftype =~ /berkeley/i) {
    print "Retrieving $type file $file\n";
    tie my %hash, $type, "$file" or die "Could not open $type file: $!\n";

    # avoid code refs (some very old version of PodWiki leaved
    # code-refs in .podattributes)
    my $str = Data::Dumper->Dump([\%hash], [qw(newhash)]);
    untie %hash;

    my $newhash;
    eval $str;

    print "Saving struct data to file $file type Storable\n";
    lock_store($newhash, $file) or die "Can't store struct to $file: $!\n";
  }
  else {
    print "File $file is not a BerkeleyDB (DB_File | MLDBM) file. Ignoring.\n";
  }
}
else {
  print "File $file does not exist yet, ignoring.\n";
}
